HDU 5289 思路+线段树处理

给出N个数,和K

求这N个数的所有满足条件(最大数-最小数<k)的区间个数

数组b记录以当前位置开始,到最右端最多满足条件的数的个数,b数组的值可通过二分+线段树查找区间最大最小值得到

对于第二组数据

10 5

0 3 4 5 2 1 6 7 8 9

B数组为

3 7 7 7 3 1 4 3 2 1

由于当前I点取最右端值可能会导致i+1点和后面取到的点不满足条件,所有应有:b[i]<=b[i+1]+1

得B数组

3 5 4 3 2 1 4 3 2 1

ans=28

#include "stdio.h"
#include "string.h"

struct node
{
    int l,r;
    __int64 ma,mi;
}data[400010];
__int64 a[100010],b[100010];
__int64 Max(__int64 a,__int64 b)
{
    if (a<b) return b;
    else return a;
}

__int64 Min(__int64 a,__int64 b)
{
    if (a<b) return a;
    else return b;
}

void build(int l,int r,int k)
{
    int mid;
    data[k].l=l;
    data[k].r=r;
    if (l==r)
    {
        data[k].ma=data[k].mi=a[data[k].l];
        return ;
    }

    mid=(data[k].l+data[k].r)/2;

    build(l,mid,k*2);
    build(mid+1,r,k*2+1);
    data[k].ma=Max(data[k*2].ma,data[k*2+1].ma);
    data[k].mi=Min(data[k*2].mi,data[k*2+1].mi);
}

__int64 query(int l,int r,int k,int op)
{
    int mid;
    if (data[k].l==l && data[k].r==r)
    {
        if (op==0) return data[k].mi;
        else return data[k].ma;
    }

    mid=(data[k].l+data[k].r)/2;
    if (r<=data[k*2].r)
        return query(l,r,k*2,op);
    else
        if (l>data[k*2].r)
        return query(l,r,k*2+1,op);
    else
    {
        if (op==0) return Min(query(l,mid,k*2,op),query(mid+1,r,k*2+1,op));
        else return Max(query(l,mid,k*2,op),query(mid+1,r,k*2+1,op));
    }
}
int main()
{
    int t,n,k,i,l,r,mid;
    __int64 ans,ma,mi;
    scanf("%d",&t);
    while (t--)
    {
        scanf("%d%d",&n,&k);
        for (i=1;i<=n;i++)
            scanf("%I64d",&a[i]);
        build(1,n,1);

        for (i=1;i<n;i++)
        {
            l=i;r=n;
            if (data[1].ma<a[i]+k && data[1].mi>a[i]-k) l=n+1;
            while (l<=r)
            {
                mid=(l+r)/2;
                ma=query(l,mid,1,1);
                mi=query(l,mid,1,0);
                if (ma>=a[i]+k || mi<=a[i]-k) r=mid-1;
                else l=mid+1;
            }
            b[i]=l-i;
        }

        b[n]=1;

        for (i=n-1;i>=1;i--)
            if (b[i]>b[i+1]+1)
            b[i]=b[i+1]+1;

        ans=0;
        for (i=1;i<=n;i++)
            ans+=b[i];
        printf("%I64d\n",ans);
    }
    return 0;
}

版权声明:本文为博主原创文章,未经博主允许不得转载。

时间: 2024-10-27 18:38:06

HDU 5289 思路+线段树处理的相关文章

hdu 5289 关于线段树的解法 很有意思

欢迎参加--BestCoder周年纪念赛(高质量题目+多重奖励) Assignment Time Limit: 4000/2000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others) Total Submission(s): 1565    Accepted Submission(s): 754 Problem Description Tom owns a company and he is the boss. There

ACM学习历程—HDU 5289 Assignment(线段树)

Problem Description Tom owns a company and he is the boss. There are n staffs which are numbered from 1 to n in this company, and every staff has a ability. Now, Tom is going to assign a special task to some staffs who were in the same group. In a gr

HDU 1542 Atlantis 线段树+离散化+扫描线

题意:给出一些矩形的最上角坐标和右下角坐标,求这些矩形的面积并. NotOnlySuccess 线段树专辑中扫描线模板题,弱智的我对着大大的代码看了一下午才搞懂. 具体见思路见注释=.= #include <cstdio> #include <cstring> #include <algorithm> #include <vector> #define lson rt<<1,l,mid #define rson rt<<1|1,mid

HDU 1828 Picture 线段树+扫描线

题意:给你一些矩形的左上角点的坐标和右下角点的坐标,求周长并 最显而易见的思路就是对于x轴和y轴做两次扫描线,对于负数的坐标进行离散化.每次增加的值是线段变化量的绝对值.具体写法和求面积并的差不多. #include <cstdio> #include <algorithm> #include <cstring> #include <vector> using namespace std; #define lson rt << 1 , l , m

hdu 1542 Atlantis(线段树&amp;扫描线&amp;面积并)

Atlantis Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 6386    Accepted Submission(s): 2814 Problem Description There are several ancient Greek texts that contain descriptions of the fabled i

hdu 1828 Picture(线段树&amp;扫描线&amp;周长并)

Picture Time Limit: 6000/2000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 2578    Accepted Submission(s): 1363 Problem Description A number of rectangular posters, photographs and other pictures of the same shap

HDU 1166(线段树单点更新)

HDU 1166 题意:1-n个堡垒,人数在不断变化,多次查询 l-r人数和: 思路:线段树的单点更新: #include<iostream> #include<cstring> #include<cstdio> #include<string> #include<algorithm> #include<cmath> #include<map> #include<vector> #include<queu

HDU 1542 Atlantis(线段树扫描线)

http://acm.hdu.edu.cn/showproblem.php?pid=1542 Atlantis Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 6788    Accepted Submission(s): 2970 Problem Description There are several ancient Greek

POJ 1177/HDU 1828 picture 线段树+离散化+扫描线 轮廓周长计算

求n个图矩形放下来,有的重合有些重合一部分有些没重合,求最后总的不规则图型的轮廓长度. 我的做法是对x进行一遍扫描线,再对y做一遍同样的扫描线,相加即可.因为最后的轮廓必定是由不重合的线段长度组成的,这样理论上是对的 要注意处理高度相同的线段,把底边优先处理(在代码里就是f标记为1的线段),因为若是一个矩形的底边和另一个矩形的上边重合,则这个轮廓肯定不能算 不过POJ和HDU的数据好像都比较弱,我没进行上面的细节处理也AC了,不过一个很简单的数据就会不对,所以还是要处理一下才是真正正确的代码 我